package com.aliyun.chatbot.channel.utils;

import io.github.furstenheim.CopyDown;
import io.github.furstenheim.Options;
import io.github.furstenheim.OptionsBuilder;
import lombok.extern.slf4j.Slf4j;

/**
 * @author kelin
 * @date 2024/8/13
 */
@Slf4j
public class RichTextUtils {

    public static String richTextToText(String text) {
        try {
            log.info("richTextToTextOriginText: " + text);
            if (text.trim().endsWith("</div>")) {

                OptionsBuilder optionsBuilder = OptionsBuilder.anOptions();
                Options options = optionsBuilder
                    .build();
                CopyDown converter = new CopyDown(options);
                return converter.convert(text);
            } else {
                text = text.replaceAll("```.*?\\s", "```");
            }
            return text;
        } catch (Exception e) {
            log.warn("richTextToText error: " + e.getMessage());
        }
        return text;
    }

}

