package com.aliyun.chatbot.channel.wechat.work;

import com.alibaba.fastjson2.JSON;

import com.aliyun.chatbot.channel.base.ChannelMsgSender;
import com.aliyun.chatbot.channel.utils.OkHttpUtils;
import com.aliyun.chatbot.channel.utils.RichTextUtils;
import com.aliyun.chatbot.channel.wechat.work.WechatWorkOutputMsg.MarkdownMsg;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.BooleanUtils;

/**
 * @author kelin
 * @date 2024/8/8
 */
@Slf4j
public class WechatWorkClientMsgSender extends ChannelMsgSender<WechatWorkChatContext> {

    public WechatWorkClientMsgSender(WechatWorkChatContext context) {
        super(context);
    }

    @Override
    public void preSengMsg() {

    }

    @Override
    public void sendMsg(String originResp, String reply, Boolean streamEnd) throws Exception {
        if (BooleanUtils.isFalse(streamEnd)) {
            return;
        }
        WechatWorkInputMsg msg = context.getMsg();
        String url = "https://qyapi.weixin.qq.com/cgi-bin/message/send?debug=1&access_token="
            + context.getWxTokenClient().getToken();
        reply = RichTextUtils.richTextToText(reply);
        WechatWorkOutputMsg outputMsg = new WechatWorkOutputMsg().setAgentid(msg.getAgentId())
            .setTouser(msg.getFromUserName())
            .setMarkdown(new MarkdownMsg().setContent(reply))
            .setAgentid(msg.getAgentId());

        String sendMsgResp = OkHttpUtils.postJsonParams(url, JSON.toJSONString(outputMsg));
        log.info("sendMsgResp: {}", sendMsgResp);
    }

    @Override
    public void postSendMsg() {

    }

}
